#include "NaptrPort.hh"
#include "naptrPort_layer_factory.hh"
#include "loggers.hh"

namespace AtsImsIot__TestSystem {

  NaptrPort::NaptrPort(const char *par_port_name): NaptrPort_BASE(par_port_name), _cfg_params(), _layer_params(), _layer(nullptr), _time_key("NaptrPort::outgoing_send") {
    // Nothing to do
  } // End of constructor

  NaptrPort::~NaptrPort() {
    loggers::get_instance().log(">>> NaptrPort::~NaptrPort");

    if (_layer != nullptr) {
      delete _layer;
    }
  } // End of destructor

  void NaptrPort::set_parameter(const char * parameter_name, const char * parameter_value)
  {
    loggers::get_instance().log("NaptrPort::set_parameter: %s=%s", parameter_name, parameter_value);
    _cfg_params.insert(std::pair<std::string, std::string>(std::string(parameter_name), std::string(parameter_value)));
  }

  /*void NaptrPort::Handle_Fd_Event(int fd, boolean is_readable,
    boolean is_writable, boolean is_error) {}*/

  void NaptrPort::Handle_Fd_Event_Error(int /*fd*/)
  {

  }

  void NaptrPort::Handle_Fd_Event_Writable(int /*fd*/)
  {

  }

  void NaptrPort::Handle_Fd_Event_Readable(int /*fd*/)
  {

  }

  /*void NaptrPort::Handle_Timeout(double time_since_last_call) {}*/

  void NaptrPort::user_map(const char * system_port)
  {
    loggers::get_instance().log(">>> NaptrPort::user_map: %s", system_port);
    // Build layer stack
    params::iterator it = _cfg_params.find(std::string("params"));
    if (it != _cfg_params.end()) {
      loggers::get_instance().log("NaptrPort::user_map: %s", it->second.c_str());
      // Setup parameters
      params::convert(_layer_params, it->second); // TODO This _layer_params seems to be useless
      // Create layer
      _layer = layer_stack_builder::get_instance()->create_layer_stack(it->second.c_str());
      if (static_cast<naptr_layer *>(_layer) == nullptr) {
        loggers::get_instance().error("NaptrPort::user_map: Invalid stack configuration: %s", it->second.c_str());
      }
      static_cast<naptr_layer *>(_layer)->add_upper_port(this);

    } else {
      loggers::get_instance().error("NaptrPort::user_map: No layers defined in configuration file");
    }
  } // End of user_map method

  void NaptrPort::user_unmap(const char * system_port)
  {
    loggers::get_instance().log(">>> NaptrPort::user_unmap: %s", system_port);

    // Reset layers
    if (_layer != nullptr) {
      delete _layer;
      _layer = nullptr;
    }
  } // End of user_unmap method

  void NaptrPort::user_start()
  {
    loggers::get_instance().log(">>> NaptrPort::user_start");

  } // End of user_start method

  void NaptrPort::user_stop()
  {
    loggers::get_instance().log(">>> NaptrPort::user_stop");

  } // End of user_stop method

  void NaptrPort::receiveMsg (const AtsImsIot__TypesAndValues::NAPTRmessage& p_ind, const params& p_params) {
    loggers::get_instance().log_msg(">>> NaptrPort::receive_msg: ", p_ind);
    
    // Sanity check
    if (!p_ind.is_bound()) {
      return;
    }

      incoming_message(p_ind);
    
  } // End of method receiveMsg
  
  void NaptrPort::outgoing_send(const AtsImsIot__TypesAndValues::NAPTRmessage& send_par)
  {
    loggers::get_instance().log_msg(">>> NaptrPort::outgoing_send: ", send_par);

    float duration;
    loggers::get_instance().set_start_time(_time_key);
    params params;
    static_cast<naptr_layer*>(_layer)->sendMsg(send_par, params);
    loggers::get_instance().set_stop_time(_time_key, duration);
  } // End of outgoing_send
  
}

